
--=== siege by Lisa ===--


-----------Initialize Variables-----------
siege = {};
siege_Settings = {};
siege.issiegeInitialized = false;
siege.playerName = "";      
siege.TotalCount = 150;
siege.CountDown = TotalCount;
siege.EndCount = 1;
siege.DeciTime = 0;
siege.Reset = false;
siege.Time = 0
siege_once = false

-----------Constants-----------
siege.PLUGIN_NAME 	= "siege";
siege.PLUGIN_VERSION	= 1.1;
siege.PLUGIN_CREDIT	= "Lisa";
siege.PLUGIN_TITLE 	= siege.PLUGIN_NAME .. " " .. siege.PLUGIN_VERSION .. " (by " ..siege.PLUGIN_CREDIT .. ")";

-----------read language file-----------
siege.curLocal = string.sub(GetLanguage():upper(), 1,2);
local localeFileName = "Interface/AddOns/siege/Locales/siege."..string.upper(siege.curLocal)..".lua";
local func, err = loadfile(localeFileName);
if (err) then
	dofile("Interface/AddOns/siege/Locales/siege.EN.lua");
else
	dofile(localeFileName);
end 

-----------Minimap Buttons-----------
function siege.MinimapButton_OnClick(this)
	if ( siegeConfig:IsVisible() ) then
		HideUIPanel(siegeConfig);
	else
		ShowUIPanel(siegeConfig);
	end
end

function siege.MinimapButton_OnEnter(this)
    GameTooltip:SetOwner(this, "ANCHOR_LEFT", 4, 0);
	GameTooltip:SetText(PLUGIN_TITLE, 1, 1, 1);
	GameTooltip:AddLine(UI_MINIMAPBUTTON_MOVE, 0, 0.75, 0.95);
	GameTooltip:Show();
end

-----------Register Events-----------
function siege.OnLoad(this)
    SaveVariables("siege_Settings");
	this:RegisterEvent("CHAT_MSG_SYSTEM");
    this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("UNIT_PORTRAIT_UPDATE"); --used, if it was for some reason impossible to get the playername after variables loaded 
end

--------- <OnEvent> ---------
function siege.OnEvent(event, this)
	if (event == "VARIABLES_LOADED") then
  		siege.CheckSettingsLoaded();
		if (AddonManager) then
			local addon = {
							name = siege.PLUGIN_NAME,
							version = siege.PLUGIN_VERSION,
							author = siege.PLUGIN_CREDIT,
							description = siege_Locales["DESCRIPTION"],
							icon = "Interface/AddOns/siege/Textures/cm_normal.tga",
							category = "Information",
							configFrame = siegeConfig,
							slashCommands = "/siege",
							miniButton = siege_AOMButton
			};
			if (AddonManager.RegisterAddonTable) then
				AddonManager.RegisterAddonTable(addon);
			else
				AddonManager.RegisterAddon(addon.name, addon.description, addon.icon, addon.category, addon.configFrame, addon.slashCommands, addon.miniButton, addon.version, addon.author);
			end;
			HideUIPanel(siege_MinimapButton);
		else
        	DEFAULT_CHAT_FRAME:AddMessage(string.format(siege_Locales["PLUGINLOADED"], siege.PLUGIN_TITLE), 0.5, 0.7, 1.0);
		end;
	elseif ( event == "UNIT_PORTRAIT_UPDATE" and arg1 == "player" ) then
		if ( siege.issiegeInitialized ~= true ) then
			siege.CheckSettingsLoaded();
		end
	elseif  event == "CHAT_MSG_SYSTEM" then
		siege.Chat(event,this);
	end
end

--------- <Default Settings> ---------
function siege.CheckSettingsLoaded()
    if ( siege.issiegeInitialized == true ) then
      return;
    end
         
	siege.playerName = UnitName("player");
	if ( siege.playerName == nil or siege.playerName == "" ) then
		return;
	end
	
	local DefaultSettings = {
    	["KeyWordCheck1"] = true,
    	["KeyWord1"] = "Enter Battle",
	};
	
	if(siege_Settings[siege.playerName] == nil) then
      siege_Settings[siege.playerName] = {};
	end

	for k,v in pairs(DefaultSettings) do
		if (siege_Settings[siege.playerName][k] == nil) then
      		siege_Settings[siege.playerName][k] = v;
		end
	end
	siege.issiegeInitialized = true;
	DEFAULT_CHAT_FRAME:AddMessage(string.format(siege_Locales["SETTINGSLOADED"], siege.PLUGIN_TITLE, siege.playerName), 0.5, 0.7, 1.0);
end


-----------Show Config Window-----------
function siege.OnShow()
  --fill window with current settings.
	
    siegeConfigTitleFrame_Title:SetText(siege.PLUGIN_TITLE);  
	siegeConfig_Save:SetText(siege_Locales["SAVE"]);
    siegeConfigBackdropFrame_SettingsInfo:SetText(string.format(siege_Locales["SETTINGSFORCHAR"], siege.playerName));
    siegeConfigBackdropFrame_TitleKeywords:SetText(siege_Locales["KEYWORDS"]);
	siegeConfig_KeyWordCheck1:SetChecked(siege_Settings[siege.playerName]["KeyWordCheck1"]);
	siegeConfig_KeyWord1:SetText(siege_Settings[siege.playerName]["KeyWord1"]);

end

-----------SaveSettings-----------
function siege.SaveSettings() 
	local NewSettings = {
    	["KeyWordCheck1"] = siegeConfig_KeyWordCheck1:IsChecked(),
    	["KeyWord1"] = siegeConfig_KeyWord1:GetText(),

	};

	for k,v in pairs(NewSettings) do
      	siege_Settings[siege.playerName][k] = v;
	end
	
	DEFAULT_CHAT_FRAME:AddMessage(string.format(siege_Locales["SETTINGSSAVED"], siege.PLUGIN_TITLE, siege.playerName), 0.5, 0.7, 1.0);
end

-----------Handle Tooltips-----------
function siege.Tooltip(this, type)
    GameTooltip:SetOwner(this, "ANCHOR_RIGHT", 4, 0);
	if(type=="checkbox") then
		GameTooltip:SetText(siege_Locales["CHECKBOXTOOLTIP"], 0, 0.75, 0.95);
	elseif(type=="keyword") then
		GameTooltip:SetText(siege_Locales["KEYWORDTOOLTIP"], 0, 0.75, 0.95);
	elseif(type=="save") then
		GameTooltip:SetText(siege_Locales["SAVETOOLTIP"], 0, 0.75, 0.95);
	end
	GameTooltip:Show();
end


-----------Check Chat ------------------
function siege.Chat(event,this)
	if(siege.issiegeInitialized) then
		local docheck = false;
		if(event == "CHAT_MSG_SYSTEM")then
			docheck = true;                                                             
		end
		
		if (docheck) then
			local var = string.lower(arg1);
  			if(siege_Settings[siege.playerName]["KeyWordCheck1"] and (siege_Settings[siege.playerName]["KeyWord1"] ~= nil or siege_Settings[siege.playerName]["KeyWord1"] ~= "")) then
  				if(string.find(var,string.lower(siege_Settings[siege.playerName]["KeyWord1"])) ~= nil) then
					siege.Time = 1	
					siege.WarningText(siege_Settings[siege.playerName]["KeyWord1"]);
  				end
  			end 
  		end
  	end
end
  

-----------show WarningText-----------
function siege.WarningText(warningtext)
	if(siege_Settings[siege.playerName]["ShowTextCheck"]) then
		siege_WarningText:SetText("|cffff9900"..warningtext);
		siege.FadeFired = true;
		siege.Reset = true;
		siege_WarningFrame:SetAlpha(1);
	end
end

-----------fade WarningText-----------
function siege.Warning_Tick()
	if siege.CountDown >= siege.EndCount then
		siege.DeciTime = siege.CountDown/siege.TotalCount;
		if siege.DeciTime <= 0.5 then
			siege.DeciTime = siege.DeciTime*2;
			siege_WarningFrame:SetAlpha(siege.DeciTime);
		end
	else
		siege.FadeFired = false;
		siege.CountDown = siege.TotalCount;
		siege_WarningFrame:SetAlpha(0);
	end
	if siege.Reset then
		siege.CountDown = siege.TotalCount;
		siege_WarningFrame:SetAlpha(1);
		siege.Reset = false;
	else
		siege.CountDown = siege.CountDown - 1;
	end
end

function siege_OnUpdate(frame, elapsedTime)
	if siege.Time >= 1 then
		siege.Time = siege.Time + elapsedTime
	end
	if siege.Time >= 10 and siege_once == false then
		GuildHouseWarEnterButton_OnClick()
		siege_once = true
	end
	if siege.Time >= 15 and siege_once == true then
		siege.Time = 0
		siege_once = false
	end
end
